      subroutine iniqqdip(n,ifl,io,q,ipol,rpol,list1,iproc,zy)

c-----------------------------------------------------------------------
c...  initialisation of the external wave functions (level one in 
c...  the Dyson-Schwinger recursion)
c-----------------------------------------------------------------------

      include 'declare.h'
      include 'common_masses.h'
      include 'dimensions.h'

c...  imaginary unit
      parameter(zi=(0,1))

c...  input
      dimension ifl(mxpart)
      dimension io(n)
      dimension q(mxpart,5)
      dimension ipol(n),rpol(n)
      dimension list1(0:mxproc,mxpart,3) 
c...  output amplitudes (1:4) and momenta (5:8) together 
      dimension zy(mxkmax,8)

c...  momenta in the rotated lightcone frame and subamplitudes
      dimension zq0(5),zq1(5),zq2(5),z0(4),z1(4),z2(4),z3(4)

      do i=1,n

         pt=dsqrt(q(i,1)**2+q(i,2)**2)
         pq=dsqrt(pt**2+q(i,3)**2)
         
         zq1(1)=dcmplx(q(i,4) +q(i,3),q(i,3))
         zq1(2)=dcmplx(q(i,4) -q(i,3),pt)
         zq1(3)=dcmplx(q(i,1), q(i,2))
         zq1(4)=dcmplx(q(i,1),-q(i,2))
         zq1(5)=dcmplx(parmas(ifl(i)),pq )
         
         if(q(i,4).lt.0d0)then
            zq2(2)=dcmplx(dreal(-zq1(2)),dimag(zq1(2)))
            zq2(1)=-zq1(1)
            zq2(3)=-zq1(3)
            zq2(4)=-zq1(4)
            zq2(5)= zq1(5)
         endif

         zq0(2)=dcmplx(dreal(zq1(2))*io(i),dimag(zq1(2)))
         zq0(1)=zq1(1)*io(i)
         zq0(3)=zq1(3)*io(i)
         zq0(4)=zq1(4)*io(i)
         zq0(5)=zq1(5)

         goto(41,42,43,44,45,46,47)list1(iproc,i,3)

c...  massless vector boson
 41      continue
         
         if(rpol(i).lt.0d0)then
            if(ipol(i).eq.1)call eminus(z0,zq0)
            if(ipol(i).eq.2)call  eplus(z0,zq0)
         else
            call eminus(z1,zq0)
            call  eplus(z2,zq0)
            z0(1:4)=
     .           +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .           +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
         endif

         goto 50
         
c...  massive vector boson
 42      continue
         
         if(rpol(i).lt.0d0)then
            if(ipol(i).eq.1)call eminus(z0,zq0)
            if(ipol(i).eq.2)call  eplus(z0,zq0)
            if(ipol(i).eq.3)call  elong(z0,zq0)
         else
            call eminus(z1,zq0)
            call  eplus(z2,zq0)
            call  elong(z3,zq0)
            z0(1:4)=
     .           +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .           +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
     .           +z3(1:4)
         endif

         goto 50

c...  in-going fermion
 43      continue
         
         if(q(i,4).gt.0d0)then
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.2)call  uplus(z0,zq1)
               if(ipol(i).eq.1)call uminus(z0,zq1)
            else
               call  uplus(z1,zq1)
               call uminus(z2,zq1)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         else
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.2)call  vplus(z0,zq2)
               if(ipol(i).eq.1)call vminus(z0,zq2)
            else
               call  vplus(z1,zq2)
               call vminus(z2,zq2)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         endif

         goto 50

c...  out-going fermion
 44      continue
         
         if(q(i,4).gt.0d0)then
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.1)call ubminus(z0,zq1)
               if(ipol(i).eq.2)call  ubplus(z0,zq1)
            else
               call ubminus(z1,zq1)
               call  ubplus(z2,zq1)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         else
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.1)call vbminus(z0,zq2)
               if(ipol(i).eq.2)call  vbplus(z0,zq2)
            else
               call vbminus(z1,zq2)
               call  vbplus(z2,zq2)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         endif

         goto 50
         
c...  in-going anti-fermion
 45      continue
         
         if(q(i,4).gt.0d0)then
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.1)call vbminus(z0,zq1)
               if(ipol(i).eq.2)call  vbplus(z0,zq1)
            else
               call vbminus(z1,zq1)
               call  vbplus(z2,zq1)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         else
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.1)call ubminus(z0,zq2)
               if(ipol(i).eq.2)call  ubplus(z0,zq2)
            else
               call ubminus(z1,zq2)
               call  ubplus(z2,zq2)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         endif

         goto 50

c...  out-going anti-fermion
 46      continue
         
         if(q(i,4).gt.0d0)then
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.1)call vminus(z0,zq1)
               if(ipol(i).eq.2)call  vplus(z0,zq1)
            else
               call vminus(z1,zq1)
               call  vplus(z2,zq1)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         else
            if(rpol(i).lt.0d0)then
               if(ipol(i).eq.1)call uminus(z0,zq2)
               if(ipol(i).eq.2)call  uplus(z0,zq2)
            else
               call uminus(z1,zq2)
               call  uplus(z2,zq2)
               z0(1:4)=
     .              +(dcos(rpol(i))+zi*dsin(rpol(i)))*z1(1:4)
     .              +(dcos(rpol(i))-zi*dsin(rpol(i)))*z2(1:4)
            endif
         endif

         goto 50
         
c...  scalar
 47      continue
         
         z0(1)  =1d0
         z0(2:4)=0d0

         goto 50

c...  end of wave functions
 50      continue
         
c...  amplitude
         zy(i,1:4)=z0(1:4)

c...  momenta         
         zy(i,5:6)=dreal(zq0(1:2))
         zy(i,7:8)=zq0(3:4)

      enddo

      return
      end

c-----------------------------------------------------------------------
      
      subroutine nextqdip(n,kc,imax,list,kcou,iproc,zy)

c-----------------------------------------------------------------------
c...  Dyson-Schwinger recursion constructed from level 2 
c...  up to level n-1
c-----------------------------------------------------------------------
      
      include 'declare.h'   
      include 'common_coup.h'
      include 'common_masses.h'
      include 'dimensions.h'

      parameter(NCOL=3)

      integer an(-12:44)
      data an/12,11,10,9,8,7,6,5,4,3,2,1,0,
     .     -1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,
     .     13,14,15,16,17,18,19,20,
     .     21,22,23,24,25,26,27,28,29,30,
     .     31,32,34,33,35,36,37,38,39,40,41,42,44,43/
      
      dimension list(0:mxproc,mxkmax,18,mxncc)
      dimension kcou(0:mxproc,mxncc)
      dimension zy(mxkmax,8)

      dimension z0(4),z1(4),z2(4),z3(4)
      dimension zp0(4),zp1(4),zp2(4)
      logical log1,log2,log3

      do i=n+1,imax
 	 do k=1,8
            zy(i,k)=0d0
 	 enddo
      enddo
      
      if(kcou(iproc,kc).lt.1)return

      do k=1,kcou(iproc,kc)

         ir=list(iproc,k,1,kc)
         ii=list(iproc,k,2,kc)
         
         ii1=list(iproc,k,7,kc)
         ii2=list(iproc,k,10,kc)
         ii3=list(iproc,k,13,kc)
         
         mm=list(iproc,k,3,kc)
         m1=list(iproc,k,8,kc)
         m2=list(iproc,k,11,kc)
         m3=list(iproc,k,14,kc)
         l= list(iproc,k,16,kc)
         isgn=list(iproc,k,17,kc)
         igluon=list(iproc,k,18,kc)

         j0=list(iproc,k,4,kc)
         j1=list(iproc,k,9,kc)
         j2=list(iproc,k,12,kc)
         j3=0

         if(list(iproc,k,13,kc).ne.0)j3=list(iproc,k,15,kc)

c...  z0,z1,z2,z3 amplitudes
c...  zp0 momenta
         do j=1,4
            z0(j)=0
            z1(j)=zy(j1,j)
            z2(j)=zy(j2,j)
            zp0(j)=zy(j1,j+4)+zy(j2,j+4)
            if(list(iproc,k,13,kc).ne.0)then
               z3(j)=zy(j3,j)
               zp0(j)=zp0(j)+zy(j3,j+4)
            endif
            zy(j0,j+4)=zp0(j)
         enddo
         
         goto(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)ir

 4       continue
c...  momenta
         do j=1,4
            zp1(j)=zy(j1,j+4)
            zp2(j)=zy(j2,j+4)
         enddo

         zg=zgv3(mm,m1,m2)
         if(igluon.eq.2)zg=-zg
         call xv3(z0,zp0,z1,zp1,z2,zp2,mm,zg,isgn)
         goto 99

 5       continue
         zg=zgv4(mm,m1,m2,m3)
         
         if(igluon.le.1)call xv4(z0,zp0,z1,z2,z3,mm,zg,isgn)
         if(igluon.eq.2+2)call xv4(z0,zp0,z1,z2,z3,mm,zg,isgn)
         if(igluon.eq.3+2)call xv4(z0,zp0,z2,z3,z1,mm,zg,isgn)
         if(igluon.eq.4+2)call xv4(z0,zp0,z3,z1,z2,mm,zg,isgn)
         goto 99

 1       continue
         do j=1,4
            zp1(j)=zy(j1,j+4)
            zp2(j)=zy(j2,j+4)
         enddo
         
         zgl=zgvffl(mm,m1,m2)
         zgr=zgvffr(mm,m1,m2) 
         call xvff(z0,zp0,z1,z2,mm,zgl,zgr,isgn)
         
         if(igluon.eq.2)then
            do i=1,4
               z0(i)=z0(i)/dsqrt(dble(NCOL))*dcmplx(0d0,1d0)
            enddo
         endif 
         if(igluon.eq.3)then
            do i=1,4
               z0(i)=-z0(i)/NCOL
            enddo
         endif
         goto 99

 3       continue
         if(ii.ne.2**n-2)then
            if(l.eq.2)then
               zgr=zgvffr(an(m1),-mm,m2)
c     call xffvr(z0,zp0,z1,z2,mm,zgr,isgn,parmas(mm))
c...  complex mass scheme for decaying tops 
               zmas=cdsqrt(parmas(mm)**2-dcmplx(0,1)
     .              *parmas(mm)*parwid(mm))
               call xffvr(z0,zp0,z1,z2,mm,zgr,isgn,zmas)
            elseif(l.eq.1)then
               zgl=zgvffl(an(m1),-mm,m2)
c     call xffvl(z0,zp0,z1,z2,mm,zgl,isgn,parmas(mm))
c...  complex mass scheme for decaying tops 
               zmas=cdsqrt(parmas(mm)**2-dcmplx(0,1)
     .              *parmas(mm)*parwid(mm))
               call xffvl(z0,zp0,z1,z2,mm,zgl,isgn,zmas)
            endif
         else   
            if(l.eq.1)then
               zgl=zgvffl(an(m1),-mm,m2)
               call xffvl0(z0,z1,z2,zgl,isgn)
            elseif(l.eq.2)then
               zgr=zgvffr(an(m1),-mm,m2)
               call xffvr0(z0,z1,z2,zgr,isgn)
            endif
         endif
         if(igluon.eq.2)then
            do i=1,4
               z0(i)=z0(i)/dsqrt(dble(NCOL))*dcmplx(0d0,1d0)
            enddo
         endif
         if(igluon.eq.3)then
            do i=1,4
               z0(i)=-z0(i)/NCOL
            enddo
         endif
         goto 99

 2       continue
         do j=1,4
            zp1(j)=zy(j1,j+4)
            zp2(j)=zy(j2,j+4)
         enddo

         if(ii.ne.2**n-2)then
            if(l.eq.2)then
               zgr=zgvffr(an(m1),m2,-mm)
c     call xaffvr(z0,zp0,z1,z2,mm,zgr,isgn,parmas(mm))
c...  complex mass scheme for decaying tops 
               zmas=cdsqrt(parmas(mm)**2-dcmplx(0,1)
     .              *parmas(mm)*parwid(mm))
               call xaffvr(z0,zp0,z1,z2,mm,zgr,isgn,zmas)
            elseif(l.eq.1)then
               zgl=zgvffl(an(m1),m2,-mm)
c     call xaffvl(z0,zp0,z1,z2,mm,zgl,isgn,parmas(mm))
c...  complex mass scheme for decaying tops 
               zmas=cdsqrt(parmas(mm)**2-dcmplx(0,1)
     .              *parmas(mm)*parwid(mm))
               call xaffvl(z0,zp0,z1,z2,mm,zgl,isgn,zmas)
            endif
         elseif(ii.eq.2**n-2)then
            if(l.eq.2)then
               zgr=zgvffr(an(m1),m2,-mm)
               call xaffvr0(z0,z1,z2,zgr,isgn)
            elseif(l.eq.1)then
               zgl=zgvffl(an(m1),m2,-mm)
               call xaffvl0(z0,z1,z2,zgl,isgn)
            endif
         endif

         if(igluon.eq.2)then
            do i=1,4
               z0(i)=z0(i)/dsqrt(dble(NCOL))*dcmplx(0d0,1d0)
            enddo
         endif
         if(igluon.eq.3)then
            do i=1,4
               z0(i)=-z0(i)/NCOL
            enddo
         endif
         goto 99

 6       continue
         if(ii.ne.2**n-2)then
            if(l.eq.2)then
               zgr=zgsffr(an(m1),-mm,m2)
               call xffsr(z0,zp0,z1(1),z2,mm,zgr,isgn,parmas(mm))
            elseif(l.eq.1)then
               zgl=zgsffl(an(m1),-mm,m2)
               call xffsl(z0,zp0,z1(1),z2,mm,zgl,isgn,parmas(mm))
            endif
         else   
            if(l.eq.1)then
               zgl=zgsffl(an(m1),-mm,m2)
               call xffsl0(z0,z1(1),z2,zgl,isgn)
            elseif(l.eq.2)then
               zgr=zgsffr(an(m1),-mm,m2)
               call xffsr0(z0,z1(1),z2,zgr,isgn)
            endif
         endif
         goto 99
         
 7       continue
         if(ii.ne.2**n-2)then
            if(l.eq.1)then
               zgl=zgsffl(an(m1),m2,-mm)
               call xaffsl(z0,zp0,z1(1),z2,mm,zgl,isgn,parmas(mm))
            elseif(l.eq.2)then
               zgr=zgsffr(an(m1),m2,-mm)
               call xaffsr(z0,zp0,z1(1),z2,mm,zgr,isgn,parmas(mm))
            endif
         else
            if(l.eq.2)then
               zgr=zgsffr(an(m1),m2,-mm)
               call xaffsr0(z0,z1(1),z2,zgr,isgn)
            elseif(l.eq.1)then
               zgl=zgsffl(an(m1),m2,-mm)
               call xaffsl0(z0,z1(1),z2,zgl,isgn)
            endif
         endif
         goto 99
         
 8       continue
         
         zgl=zgsffl(mm,m1,m2)
         zgr=zgsffr(mm,m1,m2) 
         call xsff(z0(1),zp0,z1,z2,mm,zgl,zgr,isgn)
         goto 99

 9       continue
         
         zg=zgvvs(mm,m1,m2)
         call xvvs(z0,zp0,z1,z2(1),mm,zg,isgn)
         goto 99
         
 10      continue

         zg=zgsvv(mm,m1,m2)
         call xsvv(z0(1),zp0,z1,z2,mm,zg,isgn)
         goto 99
         
 11      continue

         zg=zgvvss(mm,m1,m2,m3)
         call xvvss(z0,zp0,z1,z2(1),z3(1),mm,zg,isgn)
         goto 99

 12      continue
         
         zg=zgssvv(mm,m1,m2,m3)
         call xssvv(z0(1),zp0,z1(1),z2,z3,mm,zg,isgn)
         goto 99
         
 13      continue
         
         zg=zgs3(mm,m1,m2)
         call xs3(z0(1),zp0,z1(1),z2(1),mm,zg,isgn)
         goto 99
         
 14      continue
         
         zg=zgs4(mm,m1,m2,m3)
         call xs4(z0(1),zp0,z1(1),z2(1),z3(1),mm,zg,isgn)
         goto 99
         
 15      continue
         
         do j=1,4
            zp1(j)=zy(j1,j+4)
         enddo
         zg=zgssv(mm,m1,m2)
         call xssv(z0(1),zp0,z1(1),zp1,z2,mm,zg,isgn)
         goto 99
         
 16      continue
         
         do j=1,4
            zp1(j)=zy(j1,j+4)
            zp2(j)=zy(j2,j+4)
         enddo
         zg=zgvss(mm,m1,m2)
         call xvss(z0,zp0,z1(1),zp1,z2(1),zp2,mm,zg,isgn)
         goto 99
         
 99      continue

         do j=1,4
            zy(j0,j)=zy(j0,j)+z0(j)
         enddo

         log1=(list(iproc,k,5,kc).eq.list(iproc,k,6,kc).or.
     .        list(iproc,k,5,kc).eq.0)
         if(k.lt.kcou(iproc,kc))then
            log2=list(iproc,k,4,kc).ne.list(iproc,k+1,4,kc)
         else
            log2=.true.
         endif
         log3=k.le.kcou(iproc,kc)

         if(log1.and.log2.and.log3)then
            do j=1,4
               z0(j)=zy(j0,j)
            enddo
            if(ii.ne.2**n-2)then
               call propag(z0,mm,zp0)
            endif
            
            do j=1,4
               zy(j0,j)=z0(j)
            enddo 
         endif
      enddo

      return
      end
      
c-----------------------------------------------------------------------

      subroutine ampqdip(k,ifl,zy,list,kcou,iproc,zamp)

c-----------------------------------------------------------------------
c...  the total amplitude is computed at the last level, l=n, by 
c...  combining the previously computed subamplitude with the 
c...  remaining one which describes the momentum p1, the particle 
c...  number one is chosen as the ending point in the
c...  Dyson-Schwinger recursion 
c-----------------------------------------------------------------------

      include 'declare.h' 
      include 'dimensions.h'

      dimension ifl(mxpart)
      dimension zy(mxkmax,8)
      dimension list(0:mxproc,mxkmax,18,mxncc)
      dimension kcou(0:mxproc,mxncc)
      dimension zamp(mxncc)

      zamp(k)=0d0
      
      if(kcou(iproc,k).lt.1)return
      
      if(ifl(1).lt.30)then
c...  fermions
         do i=1,4
            zamp(k)=zamp(k)
     .           +zy(list(iproc,kcou(iproc,k),4,k),i)*zy(1,i)
         enddo
      elseif(ifl(1).ge.31.and.ifl(1).le.40)then
c...  vector bosons
         zamp(k)=
     .        zprod(zy(list(iproc,kcou(iproc,k),4,k),1:4),zy(1,1:4))
      elseif(ifl(1).ge.41)then
c...  scalars
         zamp(k)=
     .        zy(list(iproc,kcou(iproc,k),4,k),1)*zy(1,1)
      endif

      return
      end
