      subroutine coupling(ncur,iflcur,pcur,gqcd,wsf)

c-----------------------------------------------------------------------
c...  set the coupling constant according to the running scale or a
c...  constant value given by the user
c-----------------------------------------------------------------------

      include 'declare.h'
      include 'common_int.h'
      include 'common_qcdrun.h'
      include 'common_masses.h' 
      include 'common_phegas_mom.h'
      include 'dimensions.h'
      include 'common_strf.h'

c...  pi
      parameter(pi=3.141592653589793d0)

      dimension iflcur(mxpart),pcur(mxpart,5)
      dimension iflorg(mxpart),porg(mxpart,5)

      wsf=1d0

      if (irun.eq.1) then
c...  save original momenta and flavors
         norg=n
         iflorg(1:mxpart)=ifl(1:mxpart)
         porg(1:mxpart,1:5)=pmom(1:mxpart,1:5)
         
c...  set to current values
         n=ncur
         ifl(3:mxpart)=iflcur(3:mxpart)
         pmom(1:mxpart,1:5)=pcur(1:mxpart,1:5)
         
c...  set the coupling according to the dynamic scale
         call physics
         call qcdscale(scale)
         gqcd=dsqrt(alphas(scale)*4*pi)
         if(istruc.eq.1) call strf(wsf)

c...  restore momenta and flavors
         n=norg
         ifl(1:mxpart)=iflorg(1:mxpart)
         pmom(1:mxpart,1:5)=porg(1:mxpart,1:5)
      else
         include 'constants.h'
         if(istruc.eq.1) call strf(wsf)
      endif

      return
      end
