      subroutine pdf_reweight(ncur,iflcur,pcur,reweight)

c-----------------------------------------------------------------------
c...  pdf reweighting factor for dipole kinematics with dynamical scale
c-----------------------------------------------------------------------

      include 'declare.h'
      include 'common_int.h'
      include 'common_qcdrun.h'
      include 'common_masses.h' 
      include 'common_phegas_mom.h'
      include 'dimensions.h'

c...  pi
      parameter(pi=3.141592653589793d0)

      dimension iflcur(mxpart),pcur(mxpart,5)
      dimension iflorg(mxpart),porg(mxpart,5)

      if (irun.eq.1) then
c...  original pdf weight
         call strf(weight_orig)

c...  save original momenta and flavors
         norg=n
         iflorg(1:mxpart)=ifl(1:mxpart)
         porg(1:mxpart,1:5)=pmom(1:mxpart,1:5)
         
c...  set to current values
         n=ncur
         ifl(3:mxpart)=iflcur(3:mxpart)
         pmom(1:mxpart,1:5)=pcur(1:mxpart,1:5)
         
c...  tilde kinematics pdf weight
         call strf(weight_tilde)

c...  restore momenta and flavors
         n=norg
         ifl(1:mxpart)=iflorg(1:mxpart)
         pmom(1:mxpart,1:5)=porg(1:mxpart,1:5)

c...  calculate reweight
         reweight = weight_tilde/weight_orig
      else
         reweight = 1
      endif

      return
      end
