C---------------------------------------------------------------

      function flambda(x1,x2,x3)
      include 'declare.h'
      f=x1**2+x2**2+x3**2-dnou(2)*x1*x2-dnou(2)*x1*x3-dnou(2)*x2*x3
      flambda=dsqrt(f)
      return
      end

C---------------------------------------------------------------

       function cosij(a,b)
       include 'declare.h'
       dimension a(3),b(3)

       cosij=a(1)*b(1)+a(2)*b(2)+a(3)*b(3)
       cosij=cosij/dsqrt(a(1)**2+a(2)**2+a(3)**2)
       cosij=cosij/dsqrt(b(1)**2+b(2)**2+b(3)**2)

       return
       end

C---------------------------------------------------------------

       function scalar_product(p1,p2)
       include 'declare.h'

       dimension p1(*),p2(*)

       scalar_product=
     . p1(4)*p2(4)-p1(3)*p2(3)-p1(2)*p2(2)-p1(1)*p2(1)

       return
       end

C---------------------------------------------------------------

      subroutine cmstolab
      include 'declare.h'
      include 'common_int.h'
      include 'common_phegas_mom.h'
      include 'common_strf.h'

      dimension p(20,4)
      dimension pboo(4)

      do i=1,n
         p(i,1:4)=pmom(i,1:4)
      enddo
      
      icut=0
      if(istruc.eq.1)then
         q=ehat
         e=q/sqrt(xp1*xp2)
         pboo(4)=(xp1+xp2)*e/2
         pboo(3)=(xp1-xp2)*e/2
         pboo(1:2)=0
         do i=1,n
            call boostl(q,pboo,p(i,1:4))
         enddo
      endif
      
      pmom(1:n,1:4)=p(1:n,1:4)
      
      return
      end      

C---------------------------------------------------------------

      function rapidity(p)
      include 'declare.h'
      dimension p(4)
      
      c=p(3)/sqrt(p(1)**2+p(2)**2+p(3)**2)
      rapidity=0.5d0*log((1+c)/(1-c))
      
      return
       end

C---------------------------------------------------------------      

      function transverse(p)
      include 'declare.h'
      dimension p(4)
      
       transverse=sqrt(p(1)**2+p(2)**2)
       
       return
       end

C---------------------------------------------------------------

      SUBROUTINE BOOST(Q,PBOO,PCM,PLB)
      include 'declare.h'
      dimension PBOO(4),PCM(4),PLB(4)

         PLB(4)=(PBOO(4)*PCM(4)+PBOO(3)*PCM(3)
     .             +PBOO(2)*PCM(2)+PBOO(1)*PCM(1))/Q
         FACT=(PLB(4)+PCM(4))/(Q+PBOO(4))
         DO 10 J=1,3
  10     PLB(J)=PCM(J)+FACT*PBOO(J)

      RETURN
      END

C---------------------------------------------------------------

      SUBROUTINE BOOSTL(Q,PBOO,P)
      include 'declare.h'
      dimension PBOO(4),PCM(4),PLB(4),P(4)
         
         PCM(1:4)=P(1:4)
	 PLB(4)=(PBOO(4)*PCM(4)+PBOO(3)*PCM(3)
     .             +PBOO(2)*PCM(2)+PBOO(1)*PCM(1))/Q
         FACT=(PLB(4)+PCM(4))/(Q+PBOO(4))
         DO 10 J=1,3
  10     PLB(J)=PCM(J)+FACT*PBOO(J)
         P(1:4)=PLB(1:4)

      RETURN
      END

C---------------------------------------------------------------

       FUNCTION ph4(px,py,pz)
       include 'declare.h'
       data init/0/
       save pi
       if(init.eq.0)then
        call mypi(pi)
        init=1
       endif
       if(px**2+py**2.le.0)then
       if(pz.ge.0)ph4=0
       if(pz.lt.0)ph4=pi
       return
       endif
       S2=px**2/(px**2+py**2)
       S=DSQRT(S2)
       if(S.gt.1)then
        print*,'PH4(X) WARNING S=',S
        ph4=0
        IF(px.LT.0)ph4=pi
        return
       endif
       IF(px.LT.0)S=-DSQRT(S2)
       ph4=DACOS(S)
       IF(py.LT.0)ph4=2*pi-ph4
c       IF(px.LT.0)ph4=pi-ph4
       RETURN
       END

C---------------------------------------------------------------

       subroutine trans_p_to_zq(n,p,zq)
       include 'declare.h'
       dimension zq(n,5),p(n,5)

       do i=1,n
        pt=dsqrt(p(i,1)**2+p(i,2)**2)
        pq=dsqrt(pt**2+p(i,3)**2)
        zq(i,1)= dcmplx(p(i,4)+p(i,3),p(i,3))
        zq(i,2)= dcmplx(p(i,4)-p(i,3),pt)
        zq(i,3)= dcmplx(p(i,1), p(i,2))
        zq(i,4)= dcmplx(p(i,1),-p(i,2))
        zq(i,5)= dcmplx( p(i,5) , pq )
       enddo

        return
        end

C---------------------------------------------------------------

       subroutine transform(n,zq,p)
       include 'declare.h'
       dimension zq(n,5),p(n,5)

        do i=1,n 
         p(i,4)=dreal(zq(i,1)+zq(i,2))/2
         p(i,3)=dreal(zq(i,1)-zq(i,2))/2
         p(i,1)=dreal(zq(i,3))
         p(i,2)=dimag(zq(i,3))
         p(i,5)=dreal(zq(i,5))
        enddo

        return
        end

